include masm32rt.inc

RegisterTTClass proto hInst:HINSTANCE
CreateTT proto hParent:HWND,psz:PCHAR,x:DWORD,y:DWORD,bVisible:BOOL,hInst:HINSTANCE
WM_MOVE_TT	EQU (WM_USER + 1) ; wParam = x, lParam = y

.data?
	hInstance		HINSTANCE	?
.code
WND_DATA struct
	hEdit		HWND	?
	hToolTip	HWND	?
	IDT			DWORD	?
	state		DWORD	?
WND_DATA ends

main proc
LOCAL msg:MSG
LOCAL wc:WNDCLASSEX
	
	mov hInstance,rv(GetModuleHandle,0)
	invoke RegisterTTClass,eax
		
	mov hInstance,rv(GetModuleHandle,0)
	mov wc.hInstance,eax
	mov wc.cbSize,SIZEOF wc
	mov wc.style,CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc,WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,SIZEOF WND_DATA
	mov wc.lpszClassName,chr$("WinClass32")
	mov wc.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wc.hIconSm,eax
	mov wc.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	mov wc.lpszMenuName,0
	mov wc.hbrBackground,COLOR_GRAYTEXT
	invoke RegisterClassEx,ADDR wc
	mov edi,rv(CreateWindowEx,0,wc.lpszClassName,"Main Window",WS_SYSMENU or WS_SIZEBOX or WS_VISIBLE or WS_MINIMIZEBOX or WS_MAXIMIZEBOX,100,100,200,200,0,0,hInstance,0)

	.while 1
		invoke GetMessage,ADDR msg,0,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage,ADDR msg
		invoke DispatchMessage,ADDR msg		
	.endw

	exit
	
main endp

WndProc proc uses ebx esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL msg:MSG
LOCAL rect:RECT

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,0
	.elseif uMsg == WM_CREATE
		invoke SetWindowLong,hWnd,WND_DATA.hEdit,rv(CreateWindowEx,0,"EDIT",0,WS_CHILD or WS_VISIBLE,40,20,100,20,hWnd,0,hInstance,0)
    	mov ebx,rv(CreateTT,hWnd,"WARNING: CAPS LOCK on",300,300,0,hInstance)
    	invoke SetWindowLong,hWnd,WND_DATA.hToolTip,ebx
    	
    	mov ebx, rv(AddAtom,"IDT_CHK_CAPSLOCK")
    	invoke SetWindowLong,hWnd,WND_DATA.IDT,ebx
    	invoke SetTimer,hWnd,ebx,25,0
    	invoke SetWindowLong,hWnd,WND_DATA.state,0
    .elseif uMsg == WM_TIMER
        .if wParam == rv(GetWindowLong,hWnd,WND_DATA.IDT)
            mov ebx,rv(GetWindowLong,hWnd,WND_DATA.state)
            mov edx,rv(GetKeyState,VK_CAPITAL)
            .if  edx & 1 && !ebx
                invoke SetWindowLong,hWnd,WND_DATA.state,1
            .elseif !(edx & 1) && ebx
                invoke SetWindowLong,hWnd,WND_DATA.state,0
                mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hEdit)
                .if rv(GetFocus) == ebx
                	mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hToolTip)
                	invoke ShowWindow,ebx,SW_HIDE
                .endif
            .endif
            mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hEdit)
            mov esi,rv(GetWindowLong,hWnd,WND_DATA.state)
            .if rv(GetFocus) == ebx && esi
               	invoke ShowWindow,rv(GetWindowLong,hWnd,WND_DATA.hToolTip),SW_SHOWNA
            .endif
        .endif
	.elseif uMsg == WM_MOVE
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hEdit)
		invoke GetWindowRect,ebx,ADDR rect
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hToolTip)
		mov ecx,rect.right
		sub ecx,rect.left
		shr ecx,1
		add ecx,rect.left
		invoke SendMessage,ebx,WM_MOVE_TT,ecx,rect.bottom		
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
	
WndProc endp

CreateTT proc hParent:HWND,psz:PCHAR,x:DWORD,y:DWORD,bVisible:BOOL,hInst:HINSTANCE
	
	.if hParent
		or edx,WS_CHILD
	.endif
	fn CreateWindowEx,WS_EX_TOPMOST,"TTClass",psz,WS_POPUP,x,y,0,0,hParent,0,hInst,0
	.if bVisible
		push eax
		invoke ShowWindow,eax,SW_SHOWNA
		pop eax
	.endif
	ret
	
CreateTT endp

RegisterTTClass proc hInst:HINSTANCE
LOCAL wc:WNDCLASSEX

	m2m wc.hInstance,hInst
	mov wc.cbSize,SIZEOF wc
	mov wc.style,CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc,TTWndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,SIZEOF HDC + SIZEOF HWND
	mov wc.lpszClassName,chr$("TTClass")
	mov wc.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wc.hIconSm,eax
	mov wc.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	mov wc.lpszMenuName,0
	mov wc.hbrBackground,0
	invoke RegisterClassEx,ADDR wc

	ret
	
RegisterTTClass endp

TTWndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL rect:RECT
LOCAL pt[4]:POINT
LOCAL ps:PAINTSTRUCT
LOCAL hdc:HDC
LOCAL _size:_SIZE
LOCAL cc:DWORD
LOCAL nx:DWORD
LOCAL ny:DWORD
LOCAL psz:PCHAR

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,0
	.elseif uMsg == WM_DESTROY
		invoke DeleteDC,rv(GetWindowLong,hWnd,0)
		mov ebx,rv(GetWindowLong,hWnd,SIZEOF HDC)
		.if rv(GetWindowLong,ebx,GWL_USERDATA)
			free eax
		.endif
	.elseif uMsg == WM_CREATE
		mov edi,rv(GetDC,rv(GetDesktopWindow))
		mov hdc,rv(CreateCompatibleDC,edi)
		
		.if rv(GetWindowTextLength,hWnd)
			mov cc,eax
			lea esi,[eax+1]
			mov ebx,alloc(esi)
			mov psz,ebx
			invoke GetWindowText,hWnd,ebx,esi
			invoke GetTextExtentPoint32,hdc,ebx,cc,ADDR _size
		.else
			mov cc,0
			mov _size.x,0
			mov _size.y,0
		.endif
		
		mov nx,5+5
		mov ny,5+5+15
		mov eax,_size.x
		add nx,eax
		mov eax,_size.y
		add ny,eax
		
		.if nx < 30
			mov nx,30
		.endif
		
		invoke DeleteObject,rv(SelectObject,hdc,rv(CreateCompatibleBitmap,edi,nx,ny))
		invoke ReleaseDC,rv(GetDesktopWindow),edi
		invoke GetWindowRect,hWnd,ADDR rect
		mov edx,rect.left
		mov eax,nx
		shr eax,1
		sub edx,eax
		invoke SetWindowPos,hWnd,0,edx,rect.top,nx,ny,SWP_NOZORDER

		mov ebx,rv(CreateRoundRectRgn,0,15,nx,ny,2*5,2*5)
		
		mov edx,nx
		shr edx,1
		mov pt.x,edx
		mov pt.y,0
		m2m pt[8].x,nx
		sub pt[8].x,5
		mov pt[8].y,15
		m2m pt[2*8].x,nx
		mov eax,nx
		shr eax,2
		add eax,5+5
		sub pt[2*8].x,eax
		mov pt[2*8].y,16
		m2m pt[3*8].x,pt.x
		m2m pt[3*8].y,pt.y
		invoke CreatePolygonRgn,ADDR pt,4,ALTERNATE	
		invoke CombineRgn,ebx,ebx,eax,RGN_OR

		mov esi,rv(CreateSolidBrush,0C6FFFFh)
		invoke FillRgn,hdc,ebx,esi
		invoke FrameRgn,hdc,ebx,rv(GetStockObject,BLACK_BRUSH),1,1
		invoke SetWindowRgn,hWnd,ebx,0
		
		invoke SetBkColor,hdc,0C6FFFFh
		invoke SetTextColor,hdc,0
		.if cc
			fn TextOut,hdc,5,15+5,psz,cc
		.endif
		invoke DeleteObject,esi
		invoke DeleteObject,ebx
		
		invoke SetWindowLong,hWnd,0,hdc

		.if cc
			free psz
		.endif
	.elseif uMsg == WM_MOVE_TT
		invoke GetClientRect,hWnd,ADDR rect
		mov edx,rect.right
		shr edx,1
		sub wParam,edx
		invoke SetWindowPos,hWnd,0,wParam,lParam,0,0,SWP_NOZORDER or SWP_NOSIZE
		mov eax,1
		ret
	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		mov hdc,rv(GetWindowLong,hWnd,0)
		mov edx,ps.rcPaint.right
		sub edx,ps.rcPaint.left
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top
		invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,hdc,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
		invoke EndPaint,hWnd,ADDR ps
	.elseif uMsg==WM_NCPAINT
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
	
TTWndProc endp
end main